import es
import popuplib
import playerlib
import gamethread
from donormod import donormod as donor

benefit = "Admin"
monthly = "Monthly"

slay = []
mute = []
kick = []
ban = []

def load():
    donor.registerbenefit(benefit, 5000, "Admin Slay/Mute/Kick/Ban", monthly, True)
    donor.registersettingsmenu(benefit, "Donor Admin", "donoradmin")
    menu = popuplib.create('donoradmin')
    menu.addline('~~ %s ~~' % benefit)
    menu.addline('--------------------')
    menu.addline(' ')
    menu.addline('->1. Slay!')
    menu.addline('->2. Mute!')
    menu.addline('->3. Kick!')
    menu.addline('->4. Ban!')
    menu.addline(' ')
    menu.addline('--------------------')
    menu.addline('->8. Back')
    menu.addline('->0. Cancel')
    menu.menuselect = donoradmin_menuselect

def donoradmin_menuselect(userid, choice, menuname):
    steamid = es.getplayersteamid(userid)
    #slay
    if choice == 1:
        if steamid not in slay:
            sendpunishmentmenu(userid, 'slay')
        else:
            donor.tell(userid, "You may only Slay once every 30 seconds!")
            donor.sendbenefitsettingmenu(userid, benefit)
    #mute
    if choice == 2:
        if steamid not in mute:
            sendpunishmentmenu(userid, 'mute')
        else:
            donor.tell(userid, "You may only Mute once every 60 seconds!")
            donor.sendbenefitsettingmenu(userid, benefit)
    #kick
    if choice == 3:
        if steamid not in kick:
            sendpunishmentmenu(userid, 'kick')
        else:
            donor.tell(userid, "You may only Kick once every 60 seconds!")
            donor.sendbenefitsettingmenu(userid, benefit)
    #ban
    if choice == 4:
        if steamid not in ban:
            sendpunishmentmenu(userid, 'ban')
        else:
            donor.tell(userid, "You may only Ban once every 5 Mins!")
            donor.sendbenefitsettingmenu(userid, benefit)

    if choice == 8:
        donor.sendbenefitsettingsmenu(userid)

def sendpunishmentmenu(userid, punishment): 
    punishmentmenu = popuplib.easymenu(punishment, '_popup_choice', punishmentmenu_playerSelected) 
    punishmentmenu.settitle('Select a player to %s:' % punishment) 
    playerlist = playerlib.getPlayerList('#all') 
    for player in playerlist: 
        t_userid = int(player) 
        t_name = player.get('name') 
        punishmentmenu.addoption(t_userid, t_name) 
    punishmentmenu.send(userid)
    punishmentmenu.menuselect = punishmentmenu_back


def punishmentmenu_back(userid, select, menuname):
    if select == 10:
        donor.sendbenefitsettingmenu(userid, benefit)

def punishmentmenu_playerSelected(caller, target, menuname):
    steamid = es.getplayersteamid(caller)
    if menuname == 'kick':
        es.msg('#multi', '#default[#lightgreenDonor#default|#green%s#default] #lightgreenHas Kicked Player #default%s' % (es.getplayername(caller), es.getplayername(target)))
        kick.append(steamid)
        es.server.queuecmd('ma_kick %s' % target)
        gamethread.delayed(60, removewait, (steamid, "Kick"))
    elif menuname == 'mute':
        es.msg('#multi', '#default[#lightgreenDonor#default|#green%s#default] #lightgreenHas Muted Player #default%s' % (es.getplayername(caller), es.getplayername(target)))
        mute.append(steamid)
        es.server.queuecmd('ma_mute %s 5' % target)
        gamethread.delayed(60, removewait, (steamid, "Mute"))
    elif menuname == 'slay':
        es.msg('#multi', '#default[#lightgreenDonor#default|#green%s#default] #lightgreenHas Slain Player #default%s' % (es.getplayername(caller), es.getplayername(target)))
        slay.append(steamid)
        es.server.queuecmd('ma_slay %s' % target)
        gamethread.delayed(30, removewait, (steamid, "Slay"))
    elif menuname == 'ban':
        es.msg('#multi', '#default[#lightgreenDonor#default|#green%s#default] #lightgreenHas Banned Player #default%s' % (es.getplayername(caller), es.getplayername(target)))
        ban.append(steamid)
        es.server.queuecmd('ma_ban %s 5' % target)
        gamethread.delayed(300, removewait, (steamid, "Ban"))
    donor.sendbenefitsettingmenu(caller, benefit)

def removewait(steamid, act):
    if act == "Slay":
        slay.remove(steamid)
    if act == "Mute":
        mute.remove(steamid)
    if act == "Ban":
        ban.remove(steamid)
    if act == "Kick":
        kick.remove(steamid)
