import es
import random
import popuplib
import os
import cPickle
from donormod import donormod as donor

benefit = "Tracers"
colors = {
          "red":"250 0 0",
          "green":"0 250 0",
          "blue":"0 0 2500",
          "yellow":"250 250 0",
          "pink":"255 105 180",
          "white":"250 250 250"
          }

colornames = ["red", "green", "blue", "yellow", "pink"]
colorsettings = {}

def load():
    donor.registerbenefit(benefit, 10, "Tracers 50 Pack", 50)
    donor.registersettingsmenu(benefit, benefit + " Color Settings", "tcolor")
    menu = popuplib.create('tcolor')
    menu.addline('~~ %s ~~' % benefit + " Color Settings")
    menu.addline('--------------------')
    menu.addline(' ')
    menu.addline('->1. Red!')
    menu.addline('->2. Blue!')
    menu.addline('->3. Green!')
    menu.addline('->4. Yellow!')
    menu.addline('->5. Pink!')
    menu.addline('->6. White!')
    menu.addline('->7. Random!')
    menu.addline(' ')
    menu.addline('--------------------')
    menu.addline('->8. Back')
    menu.addline('->0. Cancel')
    menu.menuselect = tcolor_menuselect
    es.server.queuecmd("eventscripts_noisy 1")
    get_database()

def unload():
    save_database()

def get_database():
   a = es.getAddonPath('donormod') + '/benefits/tracer/database.db'
   if os.path.isfile(a):
      global colorsettings
      pd = open(a)
      colorsettings = cPickle.load(pd)
      pd.close()

def save_database():
    pd = open(es.getAddonPath('donormod') + '/benefits/tracer/database.db', 'w')
    cPickle.dump(colorsettings, pd)
    pd.close()

def bullet_impact(ev):
    userid = ev['userid']
    if donor.checkbenefit(userid, benefit, True):
        steamid = es.getplayersteamid(userid)
        if steamid not in colorsettings:
            addsteam(steamid, "red")
        color = colorsettings[steamid]
        if color == "random":
            color = random.choice(colornames)
        x2, y2, z2 = es.getplayerlocation(ev['userid'])
        x1, y1, z1 = (ev['x'], ev['y'], ev['z'])
        es.server.queuecmd('est_effect 3 #a 0 sprites/physcannon_bluelight2.vmt %s %s %s %s %s %s 0.5 0.5 1 %s 255' % (x1, y1, z1, x2, y2, int(z2)+60, colors[color]))

def addsteam(steamid, color):
    colorsettings[steamid] = color

def tcolor_menuselect(userid, choice, menuname):
    steamid = es.getplayersteamid(userid)
    if choice == 1:
        addsteam(steamid, "red")
    if choice == 2:
        addsteam(steamid, "blue")
    if choice == 3:
        addsteam(steamid, "green")
    if choice == 4:
        addsteam(steamid, "yellow")
    if choice == 5:
        addsteam(steamid, "pink")
    if choice == 6:
        addsteam(steamid, "white")
    if choice == 7:
        addsteam(steamid, "random")
    if choice == 8:
        popuplib.send('benefitsettingsmenu_menupopup', userid)
        return
    popuplib.send('tcolor', userid)
    donor.tell(userid, "Your tracer color is: %s!" % colorsettings[steamid])

def donor_benefit_bought(ev):
    if ev['benefit'] == benefit:
        steamid = es.getplayersteamid(userid)
        if steamid not in colorsettings:
            addsteam(steamid, "red")